VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSocketArray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event SocketClose(SocketWrapper As CSocketWrapper)
Public Event SocketConnect(SocketWrapper As CSocketWrapper)
Public Event SocketConnectionRequest(SocketWrapper As CSocketWrapper, ByVal requestID As Long)
Public Event SocketDataArrival(SocketWrapper As CSocketWrapper, ByVal bytesTotal As Long)
Public Event SocketError(SocketWrapper As CSocketWrapper, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
Public Event SocketSendComplete(SocketWrapper As CSocketWrapper)
Public Event SocketSendProgress(SocketWrapper As CSocketWrapper, ByVal bytesSent As Long, ByVal bytesRemaining As Long)
Public Event ConnectionBeginTransComplete(SocketWrapper As CSocketWrapper, ByVal TransactionLevel As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionCommitTransComplete(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionConnectComplete(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionDisconnect(SocketWrapper As CSocketWrapper, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionExecuteComplete(SocketWrapper As CSocketWrapper, ByVal RecordsAffected As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)
Public Event ConnectionInfoMessage(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionRollbackTransComplete(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionWillConnect(SocketWrapper As CSocketWrapper, ConnectionString As String, UserID As String, Password As String, Options As Long, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
Public Event ConnectionWillExecute(SocketWrapper As CSocketWrapper, Source As String, CursorType As ADODB.CursorTypeEnum, LockType As ADODB.LockTypeEnum, Options As Long, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)

Private colChilds As Collection

Public Function Add() As CSocketWrapper
Dim W As CSocketWrapper
Set W = New CSocketWrapper
W.Create Me
colChilds.Add Key:=CStr(ObjPtr(W)), Item:=W
Set Add = W
End Function

Public Sub Remove(ByVal Index As Long)
Dim W As CSocketWrapper
Set W = colChilds.Item(Index)
If W.Socket.State <> sckClosed Then W.Socket.CloseSocket
W.Dispose
Set W = Nothing
colChilds.Remove Index
End Sub

Public Sub RemovePtr(ByVal Key As Long)
Dim W As CSocketWrapper
Set W = colChilds.Item(CStr(Key))
If W.Socket.State <> sckClosed Then W.Socket.CloseSocket
W.Dispose
Set W = Nothing
colChilds.Remove CStr(Key)
End Sub

Public Sub Clear()
Do While colChilds.Count > 0
  Remove 1
Loop
End Sub

Public Property Get Item(ByVal Index As Long) As CSocketWrapper
Attribute Item.VB_UserMemId = 0
Set Item = colChilds.Item(Index)
End Property

Public Property Get ItemPtr(ByVal Key As Long) As CSocketWrapper
Set ItemPtr = colChilds.Item(CStr(Key))
End Property

Public Property Get Count() As Long
Count = colChilds.Count
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
Set NewEnum = colChilds.[_NewEnum]
End Property

Public Sub GenerateSocketClose(SocketWrapper As CSocketWrapper)
RaiseEvent SocketClose(SocketWrapper)
End Sub

Public Sub GenerateSocketConnect(SocketWrapper As CSocketWrapper)
RaiseEvent SocketConnect(SocketWrapper)
End Sub

Public Sub GenerateSocketConnectionRequest(SocketWrapper As CSocketWrapper, ByVal requestID As Long)
RaiseEvent SocketConnectionRequest(SocketWrapper, requestID)
End Sub

Public Sub GenerateSocketDataArrival(SocketWrapper As CSocketWrapper, ByVal bytesTotal As Long)
RaiseEvent SocketDataArrival(SocketWrapper, bytesTotal)
End Sub

Public Sub GenerateSocketError(SocketWrapper As CSocketWrapper, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
RaiseEvent SocketError(SocketWrapper, Number, Description, Scode, Source, HelpFile, HelpContext, CancelDisplay)
End Sub

Public Sub GenerateSocketSendComplete(SocketWrapper As CSocketWrapper)
RaiseEvent SocketSendComplete(SocketWrapper)
End Sub

Public Sub GenerateSocketSendProgress(SocketWrapper As CSocketWrapper, ByVal bytesSent As Long, ByVal bytesRemaining As Long)
RaiseEvent SocketSendProgress(SocketWrapper, bytesSent, bytesRemaining)
End Sub

Public Sub GenerateConnectionBeginTransComplete(SocketWrapper As CSocketWrapper, ByVal TransactionLevel As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionBeginTransComplete(SocketWrapper, TransactionLevel, pError, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionCommitTransComplete(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionCommitTransComplete(SocketWrapper, pError, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionConnectComplete(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionConnectComplete(SocketWrapper, pError, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionDisconnect(SocketWrapper As CSocketWrapper, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionDisconnect(SocketWrapper, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionExecuteComplete(SocketWrapper As CSocketWrapper, ByVal RecordsAffected As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionExecuteComplete(SocketWrapper, RecordsAffected, pError, adStatus, pCommand, pRecordset, pConnection)
End Sub

Public Sub GenerateConnectionInfoMessage(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionInfoMessage(SocketWrapper, pError, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionRollbackTransComplete(SocketWrapper As CSocketWrapper, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionRollbackTransComplete(SocketWrapper, pError, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionWillConnect(SocketWrapper As CSocketWrapper, ConnectionString As String, UserID As String, Password As String, Options As Long, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionWillConnect(SocketWrapper, ConnectionString, UserID, Password, Options, adStatus, pConnection)
End Sub

Public Sub GenerateConnectionWillExecute(SocketWrapper As CSocketWrapper, Source As String, CursorType As ADODB.CursorTypeEnum, LockType As ADODB.LockTypeEnum, Options As Long, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)
RaiseEvent ConnectionWillExecute(SocketWrapper, Source, CursorType, LockType, Options, adStatus, pCommand, pRecordset, pConnection)
End Sub

Private Sub Class_Initialize()
Create
End Sub

Private Sub Class_Terminate()
Dispose
End Sub

Public Sub Create()
If colChilds Is Nothing Then Set colChilds = New Collection
End Sub

Public Sub Dispose()
If Not colChilds Is Nothing Then
  Clear
  Set colChilds = Nothing
End If
End Sub
